#!/usr/bin/python2.2

## soundcardBackend.py - Contains the backend code needed for redhat-config-soundcard
## Copyright (C) 2002 Red Hat, Inc.
## Copyright (C) 2002 Brent Fox <bfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


import string
import kudzu
import os

class soundcardBackend:
    def probeCards(self):
        cards = kudzu.probe(kudzu.CLASS_AUDIO, kudzu.BUS_PCI, kudzu.PROBE_ALL)
        return cards

    def getData(self, card):
        device, module, description = card
        maker, model = string.split(description, "|")
        return device, module, maker, model

    def insmod(self, module):
        pass

    def rmmod(self, module):
        pass

    def lsmod(self):
        pass

    def playTestSound(self):
        pid = os.fork()
        path = "/usr/bin/play"
        args = [path, "/usr/share/redhat-config-soundcard/redhat-sample.wav", "-v", "2"]

        if (not pid):
            os.execv(path, args)
            
    def readFile(self):
        fd = open('/etc/modules.conf', 'r')
        lines = fd.readlines()
        fd.close()

        new_file = []

        for line in lines:
            #strip out all lines dealing with sound
            if string.find(line, "sound-slot") < 0:
                new_file.append(line)

        return new_file
    
    def writeFile(self, module):
        lines = self.readFile()

        lines.append("alias sound-slot-0 %s\n" % module)
        lines.append("post-install sound-slot-0 /bin/aumix-minimal -f /etc/.aumixrc -L >/dev/null 2>&1 || :\n")
        lines.append("pre-remove sound-slot-0 /bin/aumix-minimal -f /etc/.aumixrc -S >/dev/null 2>&1 || :\n")

#        fd = open('/etc/modules.conf', 'w')
        fd = open('modules.conf-test', 'w')

        for line in lines:
            fd.write(line)

        fd.close()


